//==========================================================================
//
//      mscc_md5_api.h
//
//      MD5 support for RedBoot
//
//==========================================================================
// ####ECOSGPLCOPYRIGHTBEGIN####                                            
// -------------------------------------------                              
// This file is part of eCos, the Embedded Configurable Operating System.   
// Copyright (C) 2006 Free Software Foundation, Inc.                        
//
// eCos is free software; you can redistribute it and/or modify it under    
// the terms of the GNU General Public License as published by the Free     
// Software Foundation; either version 2 or (at your option) any later      
// version.                                                                 
//
// eCos is distributed in the hope that it will be useful, but WITHOUT      
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or    
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License    
// for more details.                                                        
//
// You should have received a copy of the GNU General Public License        
// along with eCos; if not, write to the Free Software Foundation, Inc.,    
// 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.            
//
// As a special exception, if other files instantiate templates or use      
// macros or inline functions from this file, or you compile this file      
// and link it with other works to produce a work based on this file,       
// this file does not by itself cause the resulting work to be covered by   
// the GNU General Public License. However the source code for this file    
// must still be made available in accordance with section (3) of the GNU   
// General Public License v2.                                               
//
// This exception does not invalidate any other reasons why a work based    
// on this file might be covered by the GNU General Public License.         
// -------------------------------------------                              
// ####ECOSGPLCOPYRIGHTEND####                                              
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Lars Povlsen
// Contributors: 
// Date:         2016-01-27
// Purpose:      
// Description:  
//              
// This code is part of RedBoot (tm).
//
//####DESCRIPTIONEND####
//
//==========================================================================

#ifndef __MSCC_MD5_H__
#define __MSCC_MD5_H__

#ifndef md5_u8
#define md5_u8  unsigned char
#endif

#ifndef md5_u32
#define md5_u32 unsigned int
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Functions and structs are prefixed with 'mscc_' to avoid name-clashes. */
struct mscc_MD5Context {
  md5_u32 buf[4];
  md5_u32 bits[2];
  md5_u8  in[64];
};

#include <stddef.h> /* For size_t */
#include <string.h> /* For memcpy(), etc. */
#define MD5_MAC_LEN 16
void mscc_MD5Init(struct mscc_MD5Context *ctx);
void mscc_MD5Update(struct mscc_MD5Context *ctx, md5_u8 const *buf, unsigned len);
void mscc_MD5Final(md5_u8 digest[MD5_MAC_LEN], struct mscc_MD5Context *ctx);

#ifdef __cplusplus
}
#endif
#endif /* __MSCC_MD5_H__ */

